#include <stdio.h>
#include <stdlib.h>

#include "f2c.h"

/* Common Block Declarations */
struct {
    double q;
} blockq_;

#define blockq_1 blockq_

int main(void)
{
    /* Builtin functions */
    double atan(double);
    double sqrt(double);

    /* Local variables */
    extern int f_c();
    static double h__;
    static int i__, j, m;
    static double p, r__, w, y, h0;
    static int k0;
    static double ay[13], dy, xk, xn, yn;
    static int nx;
    static double xs[2], yt;
    static int kd2, kp1, kp2, kp3;
    static double rab[351], ady[12], dyn, ayt[13], dyt, ad2y[11];
    extern int de88d_c( );
    static int inch;
    static double dely;
    static int imax;
    static double delay[13], deldy;
    static int iordy, iniapr;
    int i__1, i__2;

    blockq_1.q = .0625;
    m = 1;
    xn = 0.;
    yn = -atan(blockq_1.q);
    dyn = blockq_1.q * 2. / (blockq_1.q * blockq_1.q + 1.);
    iordy = 2;
    h0 = 1.;
    xk = 1.;
    yt = atan(blockq_1.q);
    dyt = dyn;
    k0 = 10;
    imax = 5;
    iniapr = 1;
    h__ = h0;

    de88d_c((U_fp)f_c, &m, &xn, &yn, &dyn, &xk, &k0, &iniapr, &imax, &iordy,
             &h__, &y, &dy, &nx, xs, ay, ady, ad2y, rab);

    dely = yt - y;
    deldy = dyt - dy;

    printf("\n ------------------------------------------------------------\n");
    printf("\n nx=%3i  xs=\n", nx);
    printf("\n %21.14e %21.14e\n\n", xs[0], xs[1]);

    printf("\n h0=%21.14e k0=%3i iniapr= %1i imax=%3i iordy=%1i \n\n",h0,k0,iniapr,imax, iordy);

    printf("\n y= %21.14e\n",y);
    printf("\n yt=%21.14e\n",yt);
    printf("\n dely= %23.14e \n\n", dely);

    printf("\n dy= %21.14e\n",dy);
    printf("\n dyt= %21.14e\n",dyt);
    printf("\n deldy= %23.14e \n", deldy);

    kp1 = 11;
    kp2 = 12;
    kp3 = 13;

	for (i__ = 1; i__ <= nx; ++i__) {
    printf("\n\n                    COEFFICIENTS AY, ADY AND AD2Y ON %3i SEGMENT \n", i__);
    printf("\n                            Chebyshev coefficients \n");
    printf("\n              for Y                   for  Y'                for Y'' \n");

    i__1 = kp1;
    for (j = 1; j <= i__1; ++j) {
	i__2 = j - 1;

         printf("\n %3i %23.14e %23.14e %23.14e", i__2, ay[j - 1],
               ady[j - 1], ad2y[j - 1]);
		}
         printf("\n %3i %23.14e %23.14e \n %3i %23.14e", kp1, ay[kp2  - 1],
                ady[kp2 - 1],  kp2, ay[kp3 - 1] );
	    }
/*  **************************************************************** */

/* __________________PRINT EXACT COEFFICIENTS AYT __________ */
    p = (sqrt(blockq_1.q * blockq_1.q + 1.) - 1.) / blockq_1.q;
    ayt[1] = p * 2.;
    r__ = p * p;
    w = p * 2.;
/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
    kd2 = 5;
    if (FALSE_) {
	++kd2;
    }
/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
    i__2 = kd2;
    for (i__ = 1; i__ <= i__2; ++i__) {
	w = -w * r__;
	ayt[(i__ << 1) + 1] = w / (doublereal) ((i__ << 1) + 1);
/* L31: */
    }
    i__2 = kp3;
    for (inch = 1; inch <= i__2; inch += 2) {
/* L32: */
	ayt[inch - 1] = 0.;
    }
/*     AY(1,1,1)=AY(1,1,1)*0.5D0 */

    i__2 = kp3;
    for (i__ = 1; i__ <= i__2; ++i__) {
/* L34: */
	delay[i__ - 1] = ayt[i__ - 1] - ay[i__ - 1];
    }
    delay[0] = ayt[0] - ay[0] * .5;

    printf("\n\n ************************************************************************\n");
    printf("\n                            Chebyshev coefficients for  Y \n");
    printf("\n            approximate                exact                absolute error \n");

    i__2 = kp3;
    for (j = 1; j <= i__2; ++j) {
	i__1 = j - 1;
      printf("\n %3i %23.14e %23.14e %23.14e", i__1, ay[j - 1], ayt[j-1], delay[j-1]);
    }
    printf("\n");
    return 0;
} /* main */

 int f_c(double *x, double *y, double *dy,
	double *z__, int *m)
{
    /* Builtin functions */
    double tan(double);

    /* Local variables */
    static double r__;

/* ---------------------------------------- */
    r__ = tan(*y);
    *z__ = blockq_1.q * -4. * r__ * *dy / (r__ * r__ + 1.);
    return 0;
} /* f_c */
